# ory-kratos-client
Welcome to the ORY Kratos HTTP API documentation!

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.5.5-alpha.4
- Package version: v0.5.5-alpha.4
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/ory/sdk.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/ory/sdk.git`)

Then import the package:
```python
import ory_kratos_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import ory_kratos_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import ory_kratos_client
from pprint import pprint
from ory_kratos_client.api import admin_api
from ory_kratos_client.model.create_identity import CreateIdentity
from ory_kratos_client.model.create_recovery_link import CreateRecoveryLink
from ory_kratos_client.model.error_container import ErrorContainer
from ory_kratos_client.model.generic_error import GenericError
from ory_kratos_client.model.identity import Identity
from ory_kratos_client.model.login_flow import LoginFlow
from ory_kratos_client.model.recovery_flow import RecoveryFlow
from ory_kratos_client.model.recovery_link import RecoveryLink
from ory_kratos_client.model.registration_flow import RegistrationFlow
from ory_kratos_client.model.settings_flow import SettingsFlow
from ory_kratos_client.model.update_identity import UpdateIdentity
from ory_kratos_client.model.verification_flow import VerificationFlow
# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = ory_kratos_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with ory_kratos_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = admin_api.AdminApi(api_client)
    body = CreateIdentity(
        schema_id="schema_id_example",
        traits={},
    ) # CreateIdentity |  (optional)

    try:
        # Create an Identity
        api_response = api_instance.create_identity(body=body)
        pprint(api_response)
    except ory_kratos_client.ApiException as e:
        print("Exception when calling AdminApi->create_identity: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdminApi* | [**create_identity**](docs/AdminApi.md#create_identity) | **POST** /identities | Create an Identity
*AdminApi* | [**create_recovery_link**](docs/AdminApi.md#create_recovery_link) | **POST** /recovery/link | Create a Recovery Link
*AdminApi* | [**delete_identity**](docs/AdminApi.md#delete_identity) | **DELETE** /identities/{id} | Delete an Identity
*AdminApi* | [**get_identity**](docs/AdminApi.md#get_identity) | **GET** /identities/{id} | Get an Identity
*AdminApi* | [**get_schema**](docs/AdminApi.md#get_schema) | **GET** /schemas/{id} | 
*AdminApi* | [**get_self_service_error**](docs/AdminApi.md#get_self_service_error) | **GET** /self-service/errors | Get User-Facing Self-Service Errors
*AdminApi* | [**get_self_service_login_flow**](docs/AdminApi.md#get_self_service_login_flow) | **GET** /self-service/login/flows | Get Login Flow
*AdminApi* | [**get_self_service_recovery_flow**](docs/AdminApi.md#get_self_service_recovery_flow) | **GET** /self-service/recovery/flows | Get information about a recovery flow
*AdminApi* | [**get_self_service_registration_flow**](docs/AdminApi.md#get_self_service_registration_flow) | **GET** /self-service/registration/flows | Get Registration Flow
*AdminApi* | [**get_self_service_settings_flow**](docs/AdminApi.md#get_self_service_settings_flow) | **GET** /self-service/settings/flows | Get Settings Flow
*AdminApi* | [**get_self_service_verification_flow**](docs/AdminApi.md#get_self_service_verification_flow) | **GET** /self-service/verification/flows | Get Verification Flow
*AdminApi* | [**list_identities**](docs/AdminApi.md#list_identities) | **GET** /identities | List Identities
*AdminApi* | [**prometheus**](docs/AdminApi.md#prometheus) | **GET** /metrics/prometheus | Get snapshot metrics from the Hydra service. If you&#39;re using k8s, you can then add annotations to your deployment like so:
*AdminApi* | [**update_identity**](docs/AdminApi.md#update_identity) | **PUT** /identities/{id} | Update an Identity
*HealthApi* | [**is_instance_alive**](docs/HealthApi.md#is_instance_alive) | **GET** /health/alive | Check alive status
*HealthApi* | [**is_instance_ready**](docs/HealthApi.md#is_instance_ready) | **GET** /health/ready | Check readiness status
*PublicApi* | [**complete_self_service_browser_settings_oidc_settings_flow**](docs/PublicApi.md#complete_self_service_browser_settings_oidc_settings_flow) | **POST** /self-service/browser/flows/registration/strategies/oidc/settings/connections | Complete the Browser-Based Settings Flow for the OpenID Connect Strategy
*PublicApi* | [**complete_self_service_login_flow_with_password_method**](docs/PublicApi.md#complete_self_service_login_flow_with_password_method) | **POST** /self-service/login/methods/password | Complete Login Flow with Username/Email Password Method
*PublicApi* | [**complete_self_service_recovery_flow_with_link_method**](docs/PublicApi.md#complete_self_service_recovery_flow_with_link_method) | **POST** /self-service/recovery/methods/link | Complete Recovery Flow with Link Method
*PublicApi* | [**complete_self_service_registration_flow_with_password_method**](docs/PublicApi.md#complete_self_service_registration_flow_with_password_method) | **POST** /self-service/registration/methods/password | Complete Registration Flow with Username/Email Password Method
*PublicApi* | [**complete_self_service_settings_flow_with_password_method**](docs/PublicApi.md#complete_self_service_settings_flow_with_password_method) | **POST** /self-service/settings/methods/password | Complete Settings Flow with Username/Email Password Method
*PublicApi* | [**complete_self_service_settings_flow_with_profile_method**](docs/PublicApi.md#complete_self_service_settings_flow_with_profile_method) | **POST** /self-service/settings/methods/profile | Complete Settings Flow with Profile Method
*PublicApi* | [**complete_self_service_verification_flow_with_link_method**](docs/PublicApi.md#complete_self_service_verification_flow_with_link_method) | **POST** /self-service/verification/methods/link | Complete Verification Flow with Link Method
*PublicApi* | [**get_schema**](docs/PublicApi.md#get_schema) | **GET** /schemas/{id} | 
*PublicApi* | [**get_self_service_error**](docs/PublicApi.md#get_self_service_error) | **GET** /self-service/errors | Get User-Facing Self-Service Errors
*PublicApi* | [**get_self_service_login_flow**](docs/PublicApi.md#get_self_service_login_flow) | **GET** /self-service/login/flows | Get Login Flow
*PublicApi* | [**get_self_service_recovery_flow**](docs/PublicApi.md#get_self_service_recovery_flow) | **GET** /self-service/recovery/flows | Get information about a recovery flow
*PublicApi* | [**get_self_service_registration_flow**](docs/PublicApi.md#get_self_service_registration_flow) | **GET** /self-service/registration/flows | Get Registration Flow
*PublicApi* | [**get_self_service_settings_flow**](docs/PublicApi.md#get_self_service_settings_flow) | **GET** /self-service/settings/flows | Get Settings Flow
*PublicApi* | [**get_self_service_verification_flow**](docs/PublicApi.md#get_self_service_verification_flow) | **GET** /self-service/verification/flows | Get Verification Flow
*PublicApi* | [**initialize_self_service_browser_logout_flow**](docs/PublicApi.md#initialize_self_service_browser_logout_flow) | **GET** /self-service/browser/flows/logout | Initialize Browser-Based Logout User Flow
*PublicApi* | [**initialize_self_service_login_via_api_flow**](docs/PublicApi.md#initialize_self_service_login_via_api_flow) | **GET** /self-service/login/api | Initialize Login Flow for API clients
*PublicApi* | [**initialize_self_service_login_via_browser_flow**](docs/PublicApi.md#initialize_self_service_login_via_browser_flow) | **GET** /self-service/login/browser | Initialize Login Flow for browsers
*PublicApi* | [**initialize_self_service_recovery_via_api_flow**](docs/PublicApi.md#initialize_self_service_recovery_via_api_flow) | **GET** /self-service/recovery/api | Initialize Recovery Flow for API Clients
*PublicApi* | [**initialize_self_service_recovery_via_browser_flow**](docs/PublicApi.md#initialize_self_service_recovery_via_browser_flow) | **GET** /self-service/recovery/browser | Initialize Recovery Flow for Browser Clients
*PublicApi* | [**initialize_self_service_registration_via_api_flow**](docs/PublicApi.md#initialize_self_service_registration_via_api_flow) | **GET** /self-service/registration/api | Initialize Registration Flow for API clients
*PublicApi* | [**initialize_self_service_registration_via_browser_flow**](docs/PublicApi.md#initialize_self_service_registration_via_browser_flow) | **GET** /self-service/registration/browser | Initialize Registration Flow for browsers
*PublicApi* | [**initialize_self_service_settings_via_api_flow**](docs/PublicApi.md#initialize_self_service_settings_via_api_flow) | **GET** /self-service/settings/api | Initialize Settings Flow for API Clients
*PublicApi* | [**initialize_self_service_settings_via_browser_flow**](docs/PublicApi.md#initialize_self_service_settings_via_browser_flow) | **GET** /self-service/settings/browser | Initialize Settings Flow for Browsers
*PublicApi* | [**initialize_self_service_verification_via_api_flow**](docs/PublicApi.md#initialize_self_service_verification_via_api_flow) | **GET** /self-service/verification/api | Initialize Verification Flow for API Clients
*PublicApi* | [**initialize_self_service_verification_via_browser_flow**](docs/PublicApi.md#initialize_self_service_verification_via_browser_flow) | **GET** /self-service/verification/browser | Initialize Verification Flow for Browser Clients
*PublicApi* | [**revoke_session**](docs/PublicApi.md#revoke_session) | **DELETE** /sessions | Revoke and Invalidate a Session
*PublicApi* | [**whoami**](docs/PublicApi.md#whoami) | **GET** /sessions/whoami | Check Who the Current HTTP Session Belongs To
*VersionApi* | [**get_version**](docs/VersionApi.md#get_version) | **GET** /version | Get service version


## Documentation For Models

 - [CompleteSelfServiceLoginFlowWithPasswordMethod](docs/CompleteSelfServiceLoginFlowWithPasswordMethod.md)
 - [CompleteSelfServiceRecoveryFlowWithLinkMethod](docs/CompleteSelfServiceRecoveryFlowWithLinkMethod.md)
 - [CompleteSelfServiceSettingsFlowWithPasswordMethod](docs/CompleteSelfServiceSettingsFlowWithPasswordMethod.md)
 - [CompleteSelfServiceVerificationFlowWithLinkMethod](docs/CompleteSelfServiceVerificationFlowWithLinkMethod.md)
 - [CreateIdentity](docs/CreateIdentity.md)
 - [CreateRecoveryLink](docs/CreateRecoveryLink.md)
 - [ErrorContainer](docs/ErrorContainer.md)
 - [FormField](docs/FormField.md)
 - [FormFields](docs/FormFields.md)
 - [GenericError](docs/GenericError.md)
 - [GenericErrorPayload](docs/GenericErrorPayload.md)
 - [HealthNotReadyStatus](docs/HealthNotReadyStatus.md)
 - [HealthStatus](docs/HealthStatus.md)
 - [Identity](docs/Identity.md)
 - [LoginFlow](docs/LoginFlow.md)
 - [LoginFlowMethod](docs/LoginFlowMethod.md)
 - [LoginFlowMethodConfig](docs/LoginFlowMethodConfig.md)
 - [LoginViaApiResponse](docs/LoginViaApiResponse.md)
 - [Message](docs/Message.md)
 - [Messages](docs/Messages.md)
 - [RecoveryAddress](docs/RecoveryAddress.md)
 - [RecoveryFlow](docs/RecoveryFlow.md)
 - [RecoveryFlowMethod](docs/RecoveryFlowMethod.md)
 - [RecoveryFlowMethodConfig](docs/RecoveryFlowMethodConfig.md)
 - [RecoveryLink](docs/RecoveryLink.md)
 - [RegistrationFlow](docs/RegistrationFlow.md)
 - [RegistrationFlowMethod](docs/RegistrationFlowMethod.md)
 - [RegistrationFlowMethodConfig](docs/RegistrationFlowMethodConfig.md)
 - [RegistrationViaApiResponse](docs/RegistrationViaApiResponse.md)
 - [RevokeSession](docs/RevokeSession.md)
 - [Session](docs/Session.md)
 - [SettingsFlow](docs/SettingsFlow.md)
 - [SettingsFlowMethod](docs/SettingsFlowMethod.md)
 - [SettingsFlowMethodConfig](docs/SettingsFlowMethodConfig.md)
 - [SettingsViaApiResponse](docs/SettingsViaApiResponse.md)
 - [UpdateIdentity](docs/UpdateIdentity.md)
 - [VerifiableAddress](docs/VerifiableAddress.md)
 - [VerificationFlow](docs/VerificationFlow.md)
 - [VerificationFlowMethod](docs/VerificationFlowMethod.md)
 - [VerificationFlowMethodConfig](docs/VerificationFlowMethodConfig.md)
 - [Version](docs/Version.md)


## Documentation For Authorization


## sessionToken

- **Type**: API key
- **API key parameter name**: X-Session-Token
- **Location**: HTTP header


## Author




## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in ory_kratos_client.apis and ory_kratos_client.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from ory_kratos_client.api.default_api import DefaultApi`
- `from ory_kratos_client.model.pet import Pet`

Solution 1:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import ory_kratos_client
from ory_kratos_client.apis import *
from ory_kratos_client.models import *
```

